#!/bin/sh

PREREQ=""

prereqs()
{
        echo "$PREREQ"
}

case $1 in
# get pre-requisites
prereqs)
        prereqs
        exit 0
        ;;
esac

verify(){
        if [ -f $1 ] && [ -f $1_sign ]; then
                deepin-iso-verify -f $1 -s $1_sign
                return $?
        else
                return 255
        fi
}

dialogError(){
        LIBDIR=/root/usr/lib/live/mount/rootfs/filesystem.squashfs
        if [ -d ${LIBDIR}/usr/lib/ ] && [ -d "/lib" ];   then
                mount --bind ${LIBDIR}/usr/lib/ /lib
        fi
        plymouth quit 
        ${LIBDIR}/usr/bin/dialog --title "Verify Iso Error" --msgbox "$1 check fail OR $1_sign is not found.\n\n Please enter any key to restart the system."  10 100
        echo 1 > /proc/sys/kernel/sysrq
        echo b > /proc/sysrq-trigger
}

main(){
        USBDIR=/root/usr/lib/live/mount/medium

        ## 按照安装器的说法虚拟机地址有概率出现/root/run/live/medium
        ## 概率约为20%
        if [ ! -f ${USBDIR}/live/filesystem.squashfs ];   then
                USBDIR=/root/run/live/medium
        fi

        if [ "$(grep -c livecd-installer /proc/cmdline)" -ne "0" ];
        then
#                set ${USBDIR}/live/filesystem.squashfs

                if [ x$(arch) == "xx86_64" ];   then
                        set ${USBDIR}/boot/grub/grub.cfg
                        for filePath in `ls ${USBDIR}/live/vmlinuz* | grep -v "sign"`
                        do
                                set -- "$@" ${filePath}
                        done
                elif [ x$(arch) == "xaarch64" ];        then
                        set ${USBDIR}/EFI/BOOT/grub.cfg
                        for filePath in `ls ${USBDIR}/live/vmlinuz* | grep -v "sign"`
                        do
                                set -- "$@" ${filePath}
                        done
                elif [ x$(arch) == "xmips64" ]; then
                        set ${USBDIR}/boot/grub.cfg
                        set -- "$@" ${USBDIR}/boot/vmlinuz
                elif [ x$(arch) == "xloongarch64" ];    then
                        set ${USBDIR}/EFI/BOOT/grub.cfg
                        set -- "$@" ${USBDIR}/boot/vmlinuz
                elif [ x$(arch) == "xsw_64" ];    then
                        set ${USBDIR}/boot/grub/grub.cfg
                        set -- "$@" ${USBDIR}/boot/vmlinuz
                else
                        dialogError "grub.cfg"
                fi

                for bin in "$@"
                do
                        verify ${bin}
                        FLAG=$?
                        if [ x${FLAG} != "x0" ];        then
                                echo "[ FAIL ] Check ${bin} Fail..."
                                dialogError ${bin}
                        else
                                echo "[  OK  ] Check ${bin} Success..."
                        fi
                done
        fi
}

main
